#ifndef PIANO_H
#define PIANO_H

float TUNE[3] = { 1, 1.0003, 0.9996 };
#define NUM_NOTES 128

#include "filter.h"
#include "dwgs.h"
#include "reverb.h"
#include "hammer.h"
#include "types.h"

#define nlongres 8

class Piano {
 public:
  Piano(int note, float Fs, float v0, long samples);
  ~Piano();
  long go(float *out, int samples);
  float getResampleRatio();
  static void fillFrequencyTable();
  static double freqTable[NUM_NOTES];    

  float v0;
  long samples;
  long sample;
  float Fs;
  float t;
  float dt;
  float Z;
  float Zb;
  float Zh;
  float f;
  
  int nstrings;
  dwgs *string[3];
  Hammer *hammer;
  Reverb *soundboard;
  Filter shaping1;
  Filter shaping2;
  Filter shaping3;
};

#endif
